SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: 'pacman fruit ghost wallType spaceType transporterType ghostHouseDoorType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'MercedesyManfredo 5/6/2013 13:49'!
blueGhost

	^ ghost.! !

!PacManTest methodsFor: 'actors' stamp: 'MercedesyManfredo 5/6/2013 13:50'!
blueberry

	^fruit.! !

!PacManTest methodsFor: 'movements' stamp: 'MercedesyManfredo 5/2/2013 14:03'!
down

	^(0@ -1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'MercedesyManfredo 5/6/2013 15:18'!
ghostHouseDoorType

	^ghostHouseDoorType.! !

!PacManTest methodsFor: 'movements' stamp: 'MercedesyManfredo 5/2/2013 14:18'!
left

	^(-1@0)! !

!PacManTest methodsFor: 'construction block types' stamp: 'MercedesyManfredo 5/6/2013 15:16'!
leftTransporterType

	^transporterType.! !

!PacManTest methodsFor: 'actors' stamp: 'MercedesyManfredo 5/6/2013 13:50'!
pacman

	^pacman. ! !

!PacManTest methodsFor: 'movements' stamp: 'MercedesyManfredo 5/2/2013 14:17'!
right

	^(1@0)! !

!PacManTest methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 15:17'!
setUp 
	pacman := Pacman new.
	ghost := Ghost new.
	fruit := Fruit new.
	wallType := WallType new.
	spaceType := SpaceType new.
	transporterType := TransporterType new.
	ghostHouseDoorType := HouseDoorType new.
	! !

!PacManTest methodsFor: 'construction block types' stamp: 'MercedesyManfredo 5/6/2013 15:15'!
spaceType

	^spaceType. 
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'MercedesyManfredo 5/2/2013 14:02'!
up

	^(0@1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'MercedesyManfredo 5/6/2013 15:16'!
wallType

	^ wallType.! !

Object subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 14:03'!
nextPositionForHouseDoorType: aPoint 
	^self position + aPoint .! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 14:11'!
nextPostionForTransporter
	^(5@10).! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/2/2013 14:08'!
position
	^(0@0)! !

Object subclass: #Ghost
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 14:01'!
nextPositionForHouseDoorType: aPoint 
	^self position + aPoint.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 14:09'!
nextPostionForTransporter
	^self position.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/2/2013 13:38'!
position
	
	^ (0@0)! !

Object subclass: #HouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!HouseDoorType methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 14:12'!
nextPositionFor: aFigure going: aPoint 
^aFigure nextPositionForHouseDoorType: aPoint
! !

Object subclass: #Pacman
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 13:58'!
nextPositionForHouseDoorType: aPoint 
	^ self position .! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 14:10'!
nextPostionForTransporter
	^ (3@10).! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/2/2013 14:06'!
position
	position:=(0@0).
	^ position! !

Object subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/2/2013 20:00'!
nextPositionFor: aFigure going: aPoint 
	^aFigure  position + aPoint .! !

Object subclass: #TransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!TransporterType methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/6/2013 14:08'!
nextPositionFor: aFigure going: aPoint 
^aFigure nextPostionForTransporter.! !

Object subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'MercedesyManfredo 5/2/2013 19:59'!
nextPositionFor: aFigure going: aPoint 
^aFigure  position .! !
